<!-- 选择建标申请 -->
<script lang="ts" setup name="SelectBuildStandardDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { DateModelType } from 'element-plus'
import type { TableColumn } from '../../../../../components/NormalTable/table_interface'
import { getBuildList } from '@/api/equipment/standard/build'
import { SCHEDULE } from '@/utils/scheduleDict'
const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  applyName: '', // 申请单名称
  applyNo: '', // 申请单编号
  approvalStatus: '0', // 审批状态
  createTimeEnd: '', // 申请时间结束
  createTimeStart: '', // 申请时间开始
  createUserName: '', // 申请人
  formId: SCHEDULE.STANDARD_SETUP_APPROVAL, // formid
  standardName: '', // 标准名称
  limit: 5,
  offset: 1,
})
// 多选选中的内容
const checkoutList = ref([])
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const loadingTable = ref(false)
const list = ref([]) // 表格数据
const total = ref(0)
const columns = ref<TableColumn[]>([
  { text: '申请表编号', value: 'applyNo', align: 'center', width: '160' },
  { text: '申请表名称', value: 'applyName', align: 'center' },
  { text: '标准名称', value: 'standardName', align: 'center' },
  { text: '申请人', value: 'createUserName', align: 'center' },
  { text: '申请时间', value: 'createTime', align: 'center', width: '180' },
])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getBuildList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 重置
const clearList = () => {
  listQuery.value = {
    applyName: '', // 申请单名称
    applyNo: '', // 申请单编号
    approvalStatus: '0', // 审批状态
    createTimeEnd: '', // 申请时间结束
    createTimeStart: '', // 申请时间开始
    createUserName: '', // 申请人
    formId: SCHEDULE.STANDARD_SETUP_APPROVAL, // formid
    standardName: '', // 标准名称
    limit: 5,
    offset: 1,
  }
  dateRange.value = ['', '']
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择建标申请')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}
// 初始化
const initDialog = () => {
  dialogFormVisible.value = true
  fetchData()
}
// ------------------------------------------钩子------------------------------------------------
watch(dateRange, (val) => {
  if (val) {
    listQuery.value.createTimeStart = `${val[0]}`
    listQuery.value.createTimeEnd = `${val[1]}`
  }
  else {
    listQuery.value.createTimeStart = ''
    listQuery.value.createTimeEnd = ''
  }
})
defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择建标申请" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.applyNo" placeholder="申请表编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.applyName" placeholder="申请表名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.standardName" placeholder="标准名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.applyName" placeholder="申请人" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="dateRange"
          class="short-input"
          type="datetimerange"
          range-separator="至"
          format="YYYY-MM-DD HH:mm:ss"
          value-format="YYYY-MM-DD HH:mm:ss"
          start-placeholder="申请时间(开始)"
          end-placeholder="申请时间(结束)"
        />
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="false"
        :height="260"
        :page-sizes="[20]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
